%{!?_name: %define _name hp-mlnx-en}
%{!?_version: %define _version 1.5.5.7}
%{!?_release: %define _release 14}

Summary: HP NC-Series Mellanox 10GbE Driver for Linux 
Name: %{_name}
Group: System Environment
Version: %{_version}
Release: %{_release}
License: GPL/BSD
Url: http://www.hp.com
Group: System Environment/Kernel
Vendor: Helwett-Packard Company
Source: %{_name}-%{_version}.tgz
BuildRoot: %{_tmppath}/%{name}-%{version}-build

%description
This package contains the Linux driver for ConnectX EN Based Network Interface Card with 10GigE Support

%define debug_package %{nil}
%if "%{_vendor}" == "redhat"
%define whatos %(echo `cat /etc/redhat-release | cut -f 1 -d " "`)
%define isddk %(echo `cat /etc/redhat-release | cut -f 2 -d " "`)
%endif

%define xen_srvr 0
%if "%{whatos}" == "XenServer"
%if "%{isddk}" == "DDK"
%define xen_srvr 1
%define kverrel %(echo %{kernel_version} )
%define flavors_to_build %{flavour}
%endif
%endif

%if %{!?KVER:0}%{?KVER:1}
%define custom 1
%else
%define custom 0
%endif

%if "%{_host_vendor}" == "suse"
%if %{!?KVER:1}%{?KVER:0}
%ifarch x86_64
%define flav debug default kdump smp xen trace
%else
%define flav bigsmp debug default kdump kdumpae smp vmi vmipae xen xenpae pae trace
%endif
%endif

%if %{!?KVER:0}%{?KVER:1}
%define flav %(echo %{KVER} | awk -F"-" '{print $3}')
%define kverrel %(echo %{KVER} | awk -F"-" '{print $1"-"$2}')
%endif
%endif

%if "%{_vendor}" == "redhat"
%define rhel_version %(cat /etc/redhat-release | grep "Red Hat Enterprise" | cut -d " " -f 7)
%if %{!?KVER:1}%{?KVER:0}
%define flav ""
%endif
%if %{!?KVER:0}%{?KVER:1}
%define flav %(echo %{KVER} | awk -F"el5" '{print $2}')

%if "%{rhel_version}" == "6.0"
%define kverrel %(echo %{KVER} | awk -F"el6 '{print $1"el6"}')
%else
%define kverrel %(echo %{KVER} | awk -F"el5" '{print $1"el5"}')
%endif

%if "%{flav}" == ""
%define flav default
%endif
%endif
%endif

%if "%{_host_vendor}" == "suse"
BuildRequires: kernel-source kernel-syms
%define install_mod_dir updates/%{name}
%define kernel_source /usr/src/linux-obj/%{_target_cpu}
%{suse_kernel_module_package -x %flav}

%package KMP
summary: HP NC-Series Mellanox 10GbE Driver for Linux
Group: System/kernel

%description KMP
This package contains the Linux driver for ConnectX EN Based Network Interface Card with 10GigE Support

%else
%if "%{xen_srvr}" == "0"
BuildRequires: %kernel_module_package_buildreqs
Conflicts: mlnx_en
Conflicts: libmlx4
Conflicts: openib
Conflicts: ofed
Requires: kernel
Provides: %{_name}
%{kernel_module_package %flav}
%endif
%define install_mod_dir extra/%{name}
%endif

%if %{custom}
%define flavors %{flav}
%else
%define flavors %{flavors_to_build}
%endif

%package doc
Summary: Documentation for the  HP NC-Series Mellanox 10GbE Driver for Linux
Group: System/Kernel

%description doc
This package contains the documentation for the ConnectX EN Based Network Interface Card with 10GigE Support

%prep
%setup
set -- *
mkdir source
mv drivers include scripts/mlnx_en_patch.sh Module.supported kernel_patches kernel_addons makefile Makefile source
mkdir obj

%build
export EXTRA_CFLAGS='-DVERSION=\"%version\"'
for flavor in %flavors_to_build; do
	rm -rf obj/$flavor
	cp -r source obj/$flavor
	cd $PWD/obj/$flavor
	KSRC=%{kernel_source $flavor} ./mlnx_en_patch.sh
	make KSRC=%{kernel_source $flavor} 
	cd -
done
gzip -c scripts/mlx4_en.7 > mlx4_en.7.gz

%install
export INSTALL_MOD_PATH=$RPM_BUILD_ROOT
export INSTALL_MOD_DIR=%install_mod_dir
for flavor in %flavors_to_build; do 
	cd $PWD/obj/$flavor
	make KSRC=%{kernel_source $flavor} install MODULES_DIR=$INSTALL_MOD_DIR DESTDIR=$RPM_BUILD_ROOT
	cd -
done
install -D -m 644 mlx4_en.7.gz $RPM_BUILD_ROOT/%{_mandir}/man7/mlx4_en.7.gz

%postun doc
if [ -f %{_mandir}/man7/mlx4_en.7.gz ]; then
	exit 0
fi

%clean
rm -rf %{buildroot}

%files doc
%defattr(-,root,root,-)
%{_mandir}/man7/mlx4_en.7.gz

%define major_change (Severity:Critical)
%define medium_change (Severity:Medium)
%define minor_change (Severity:Minor)

%changelog
* Fri Sep 9 2009 Yevgeny Petrilin <yevgenyp@mellanox.co.il>
- Modified spec file to conform to KMP specifications %{major_change}
